package com.perforce.hws.automation;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.perforce.hws.util.ProcessHelpers;

import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

/**
 * Created by tjuricek on 2/22/16.
 */
public class DeployDebPackage implements ProcessHelpers, OsHelpers {

    static Logger logger = LoggerFactory.getLogger(DeployDebPackage.class);

    public static void main(String args[]) {
        try {
            new DeployDebPackage(args[0]).run();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    private String archivePath;

    public DeployDebPackage(String archivePath) {
        this.archivePath = archivePath;
    }

    public void run() throws Exception {
        if (isLinux()) {
            // Executing this in a shared VMWare folder makes for interesting
            // problems. Here's how I've had to run it.
            //execOrFail("sudo", "-u", "tristan", "tar", "-x", "-z", "-p", "-f", archivePath);
            execOrFail("tar", "-x", "-z", "-f", archivePath);

            Path pkg = Files.newDirectoryStream(Paths.get("."), "helix-web-services*.deb").iterator().next();
            logger.info("Installing {}", pkg);

            execOrFail("dpkg", "-i", pkg.toAbsolutePath().toString());
        } else {
            throw new IllegalStateException("OS Not supported: " + osName());
        }
    }
}
