package com.perforce.hws.automation;

/**
 * Used to exec t4 tests running in the current branch against our local
 * codebase.
 *
 * This will rebuild the project before running.
 *
 * The t4 system will launch and assign a port to an HWS server.
 */
public class ExecT4Tests implements ProjectLocations, T4TestMethods,
        Runnable, EnvironmentCleanup {

    private AutomationConfig config;

    public ExecT4Tests() {
        this.config = new AutomationConfig();
    }

    @Override
    public void run() {
        try {
            // We shut down everything else that we might have started, just to
            // avoid any conflicts.
            cleanUp();

            runTests();

        } catch (Exception e) {
            System.err.println("Test halted: " + e.getMessage());
            e.printStackTrace();
        }
    }

    public static void main(String args[]) {
        new ExecT4Tests().run();
    }


    @Override
    public AutomationConfig config() {
        return config;
    }
}
