package com.perforce.hws.automation;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.attribute.PosixFilePermission;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

import static com.perforce.hws.automation.OsUtil.isWindows;
import static java.util.Arrays.asList;
import static java.util.stream.Collectors.joining;

/**
 * Created by tristan on 11/25/15.
 */
public class FileUtil {

    public static void setExecutable(String pathStr) throws IOException {
        Path path = Paths.get(pathStr);
        if (!isWindows()) {
            Set<PosixFilePermission> permissionSet = Files.getPosixFilePermissions(path);
            permissionSet.add(PosixFilePermission.OTHERS_EXECUTE);
            permissionSet.add(PosixFilePermission.GROUP_EXECUTE);
            permissionSet.add(PosixFilePermission.OWNER_EXECUTE);
            Files.setPosixFilePermissions(path, permissionSet);
        }
    }

    public static String appendEnvPath(String cur, String toAdd) {
        if (cur == null) {
            return toAdd;
        }
        String pathSplit = isWindows() ? ";" : ":";
        String[] split = cur.split(pathSplit);
        List<String> complete = new ArrayList<>(asList(split));
        complete.add(toAdd);
        return complete.stream().collect(joining(pathSplit));
    }
}
