package com.perforce.hws.automation;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import sun.nio.ch.Net;

import java.io.IOException;
import java.net.DatagramSocket;
import java.net.ServerSocket;

/**
 */
public interface NetworkUtil {

    Logger logger = LoggerFactory.getLogger(NetworkUtil.class);

    /**
     * Checks to see if a specific port is available.
     *
     * Taken from Stackoverflow (CC-licensed): http://stackoverflow.com/a/435579/3436
     *
     * @param port the port to check for availability
     */
    default boolean isPortAvailable(int port) {
        if (port < 0 || port > 65535) {
            throw new IllegalArgumentException("Invalid start port: " + port);
        }

        ServerSocket ss = null;
//        DatagramSocket ds = null;
        try {
            ss = new ServerSocket(port);
            ss.setReuseAddress(true);
//            ds = new DatagramSocket(port);
//            ds.setReuseAddress(true);
            return true;
        } catch (IOException e) {
//            logger.debug("port " + port + " may not be available yet", e);
        } finally {
//            if (ds != null) {
//                ds.close();
//            }

            if (ss != null) {
                try {
                    ss.close();
                } catch (IOException e) {
                /* should not be thrown */
                }
            }
        }

        return false;
    }
}
