package com.perforce.hws.automation;

/**
 * Helpers to identify OS and architecture, etc, based on system properties.
 *
 * TODO: I think I'm going to deprecate this and prefer the OsHelpers interface
 */
class OsUtil {

    public static boolean isOSX() {
        return osName().startsWith("Mac OS X");
    }

    public static boolean isWindows() {
        return osName().startsWith("Windows");
    }

    public static boolean isLinux() {
        return osName().startsWith("Linux");
    }

    public static String osName() {
        return System.getProperty("os.name");
    }

    /**
     * @return e.g., "x86_64"
     */
    public static String osArch() {
        return System.getProperty("os.arch");
    }

    public static String ftpOsArch() {
        if (isLinux() && "amd64".equals(osArch())) {
            return "x86_64";
        }
        if (isWindows() && "amd64".equals(osArch())) {
            return "x64";
        }
        return osArch();
    }

    public static String nullPath() {
        if (isWindows()) {
            return "nul";
        } else {
            return "/dev/null";
        }
    }

    public static String ftpOsName() {
        if (isOSX()) {
            return "darwin90";
        } else if (isLinux()) {
            return "linux26";
        } else if (isWindows()) {
            return "nt";
        }
        throw new IllegalStateException("Can not determine platform directory " +
                "for this OS: " + osName());
    }
}
