package com.perforce.hws.automation;

import java.util.Arrays;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

/**
 * Created by tjuricek on 2/18/16.
 */
public interface VersionFileMethods {

    Pattern VERSION_FILE_KEY_VALUE = Pattern.compile("\\s*(?<key>\\S+)\\s*=\\s*(?<value>.*)\\s*;");

    /**
     * Parses the p4/Version file that is typically copied into our build or
     * distribution.
     *
     * @param content
     * @return
     */
    default Map<String, String> parseVersionFile(String content) {
        return Arrays.stream(content.split("\n"))
                .map(VERSION_FILE_KEY_VALUE::matcher)
                .filter(Matcher::matches)
                .collect(Collectors.toMap(m -> m.group("key"), m -> m.group("value")));
    }
}
